#!/bin/bash

alias cp='numactl --cpunodebind=0 --membind=0 cp'
alias mv='numactl --cpunodebind=0 --membind=0 mv'
alias su='su -'

function fio() {
    (/usr/bin/blk_monitor.sh >/dev/null &) && command fio "$@"
}

function dd() {
    (/usr/bin/blk_monitor.sh >/dev/null &) && command dd "$@"
}

wrap_geekbench() {
    if [[ -x ./geekbench_riscv64 && ! -f ./.geekbench_riscv64.bin ]]; then
        mv ./geekbench_riscv64 ./.geekbench_riscv64.bin
        cat > ./geekbench_riscv64 << EOF
#!/bin/bash
DIR="\$( cd "\$( dirname "\${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
LD_PRELOAD="/usr/lib/libmimalloc.so.2:/usr/lib/libhpfutex.so" "\${DIR}/.geekbench_riscv64.bin" "\$@"
EOF
        chmod +x ./geekbench_riscv64
    fi
}

function cd() {
        builtin cd "$@" && wrap_geekbench
}

function sudo(){
        if [ $# -eq 0 ];then
                command  sudo 
                return $?
        fi

        if [ "$1" = "su" ];then
                shift
                command sudo su - "$@"
                return $?
        fi

        local found_cmd=0
        local cmd_name=""
        for arg in "$@";do
                if [[ "$arg" == "-" || "$arg" == *=* ]];then
                        continue
                fi

                if [[ "$arg" == "dd" || "$arg" == "fio" ]];then
                        found_cmd=1
                        break
                fi
        done
        if  (( found_cmd ));then
                command sudo /bin/bash -c 'source /etc/profile.d/numa-alias.sh > /dev/null 2>&1; "$@"'\
                        bash "$@"
        else
                command sudo "$@"
        fi
}

